-- BUNDLE.E
-- One of the files that I had to rebuild 'cause the system died

include get.e
include file.e
include wildcard.e
sequence bundles,bundleFns
bundles={}
bundleFns={}
function remove(sequence list,integer indx)
    if indx=1 then
	return list[2..length(list)]
    elsif indx=length(list) then
	return list[1..length(list)-1]
    end if
    return list[1..indx-1]&list[indx+1..length(list)]
end function
global function openBundle(sequence file)
    if find(upper(file),upper(bundles)) then
	return -1
    end if
    bundles &= file
    bundleFns &= open(file,"rb")
    return bundleFns[length(bundleFns)]
end function
global constant BUNDLE_SUCCESS  = 1,
		BUNDLE_OPEN_ERR = 2,
		BUNDLE_NOT_FOUND = 3,
		BUNDLE_DATA_ERR = 4,
		BUNDLE_WRITE_ERR = 5,
		BUNDLE_NOT_FOUND2 = 6
global function unBundle(sequence bundle,sequence file)
    sequence stuff
    object line,bytes
    integer fn,indx,opened,f2
    trace(1)
    opened=0
    indx=find(upper(bundle),upper(bundles))
    if indx then
	fn=bundleFns[indx]
	opened=1
    else
	fn=open(bundle,"rb")
    end if
    if fn=-1 then
	return BUNDLE_NOT_FOUND2
    end if
    if seek(fn,0) then end if
    while 1 do
	line=gets(fn)
	if atom(line) then
	    return BUNDLE_NOT_FOUND
	end if
	line=line[1..length(line)-2]
	if equal(upper(line),upper(file)) then
	    bytes=gets(fn)
	    if atom(bytes) then
		if not opened then close(fn) end if
		return BUNDLE_DATA_ERR
	    end if
	    bytes=value(bytes)
	    if bytes[1] != GET_SUCCESS then
		if not opened then close(fn) end if
		return BUNDLE_DATA_ERR
	    end if
	    bytes=bytes[2]
	    stuff=get_bytes(fn,bytes)
	    exit
	end if
    end while
    if not opened then close(fn) end if
    f2=open(file,"wb")
    if f2=-1 then
	return BUNDLE_WRITE_ERR
    end if
    puts(f2,stuff)
    close(f2)
    return BUNDLE_SUCCESS
end function
global procedure closeBundles()
    for z = 1 to length(bundleFns) do
	if bundleFns[z] > -1 then close(bundleFns[z]) end if
    end for
    bundles={}
end procedure
global procedure closeBundle(sequence file)
    integer indx
    indx=find(upper(file),upper(bundles))
    if indx then
	close(bundleFns[indx])
	bundles=remove(bundles,indx)
    end if
end procedure
global function inBundle(sequence bundl,sequence fil)
    integer indx,bErr,fn,opened
    object line
    indx=find(upper(bundl),upper(bundles))
    bErr=1
    opened=0
    if indx then
	fn=bundleFns[indx]
	opened=1
    else
	fn=open(bundl,"rb")
    end if
    if fn=-1 then
	return BUNDLE_NOT_FOUND2
    end if
    if seek(0,fn) then end if
    while 1 do
	line=gets(fn)
	if atom(line) then
	    bErr=0
	    exit
	end if
	line=line[1..length(line)-2]
	if equal(upper(line),upper(fil)) then
	    exit
	end if
    end while
    if not opened then
	close(fn)
    end if
    return bErr
end function
