-- include file shared by huff.ex, dehuff.ex

global constant TRUE = 1, EOF = -1
global constant KEYB = 0, DISPLAY = 1, ERROR = DISPLAY
global constant GO_LEFT_CHILD = 0, GO_RIGHT_CHILD = 1, BYTE_SIZE = 8
global constant NUM_ASCII = 256

global integer plainFile, encodeFile
global sequence tree

global procedure errorPut(sequence s)
    puts(ERROR, s & '\n')
    abort(1)
end procedure

global function delete_trailing_white(sequence name)
-- get rid of blanks, tabs, newlines at end of string
    while length(name) > 0 do
	if find(name[length(name)], "\n\r\t ") then
	    name = name[1..length(name)-1]
	else
	    exit
	end if
    end while
    return name
end function

global function get_response(sequence query)
    -- It displays the query and returns the response after stripping the
    -- trailing white space. 
    sequence s
    
    puts(DISPLAY, query)
    s = gets(KEYB)
    puts(DISPLAY, '\n')
    return delete_trailing_white(s)
end function

global procedure closeFiles()
    close(plainFile)
    close(encodeFile)
end procedure

