-- DOS version of INI.EW
-- Thought question: Why do high-level languages, such as C and Euphoria, use
-- lowercase letters, whereas the lower languages, such as ASM and BASIC, use
-- all capital letters?

-- Euphoria code: puts(1,"Hello")
-- BASIC code: PRINT "Hello";
-- ASM code: MOV AH, 9
--           MOV DX, 108h
--           INT 21h
--           RET
--           DB 'Hello$'
include misc.e -- reverse()
include file.e
include get.e
global integer verbose
verbose=1
-- NEW! IE1.4a Added commentAtEnd to help Ini.e(w) identify a section marker
-- when it has a comment at the end.
global function commentAtEnd(sequence line)
    integer yes
    yes=0
    for z = length(line) to 1 by -1 do
	if line[z]=';' then
	    yes=1
	    exit
	end if
    end for
    return yes
end function
function find2(sequence findthis,sequence inthis)
    integer indx
    for z = 1 to length(inthis) do
	indx = match(findthis,inthis[z])
	if indx then
	    return indx
	end if
    end for
    return 0
end function
global function isVar(sequence st)
    integer char,hadEqual,inStr,inList
    hadEqual=0
    inList=0
    inStr=0
    for z = 1 to length(st) do
	char=st[z]
	if char='=' then
	    if not hadEqual and not inList and not inStr then
		hadEqual=1
	    end if
	elsif char=',' then
	    inList=not inList
	elsif char='\'' or char='"' then
	    inStr=not inStr
	end if
    end for
    return hadEqual
end function
    -- Snippet from user.e:
    -- Jiri Babor's trim routine. I simply renamed it.
    function trimSpaces(sequence s) --Sep. '98
      -- trim 'white space' from both ends of string s
      -- 'short-circuit' optimized
      integer c,i,j,len
	len=length(s)
	i=1
      while i<=len do
	c=s[i]
	if c=32 then i=i+1
	elsif c=10 then i=i+1
	elsif c=13 then i=i+1
	elsif c=9 then i=i+1
	else exit end if
      end while
      j=len
      while j>=i do
	c=s[j]
	if c=32 then j=j-1
	elsif c=10 then j=j-1
	elsif c=13 then j=j-1
	elsif c=9 then j=j-1
	else exit end if
      end while
      return s[i..j]
    end function
--with trace
global function parse_delim(sequence st,integer delim)
    integer indx
    sequence new
    trace(1)
    indx=1
    new={{}}
    for z = 1 to length(st) do
	if st[z]=delim then
	    indx += 1
	    new &= {{}}
	else
	    new[indx] &= st[z]
	end if
    end for
    return new
end function
without trace
function strip(sequence stg,integer char) -- Remove all ocurrences of char from
    sequence new                          -- stg.
    new=""
    for z=1 to length(stg) do
	if stg[z]!=char then
	    new &= stg[z]
	end if
    end for
    return new
end function
global function assignIConst(sequence INIConst) -- Assign INI constant to string
    return trimSpaces(INIConst[match("=",INIConst)+1..length(INIConst)])
end function
global procedure writeINIFile(sequence fName,sequence sections,sequence sectText)
    integer fn
    fn=open(fName,"w")
    if fn=-1 then
	if verbose then puts(1,"Unable to write '"&fName&"'\n"&
	       "It may be in use by another program, or read-only\n") end if
	return
    end if
    for z = 1 to length(sections) do
	puts(fn,sections[z]&'\n')
	puts(fn,strip(sectText[z],'\r')&'\n')
    end for
    close(fn)
end procedure
global function readINIFile(sequence fName) -- Return .INI file in
					    -- {sections,{text1,text2...}} form
    sequence newLine,sections,sectText
    integer fn,linesRead,numberOfSections,slice,lineIsSection,fpos
    object line
    lineIsSection=0
    newLine=""
    slice=1
    numberOfSections=0
    linesRead=0
    fn=open(fName,"r")
    if fn=-1 then
	if verbose then puts(1,"Can't find '"&fName&"'\n") end if
	return -1
    end if
    sectText={}
    sections={}
    while 1 do
	line=gets(fn)
	if atom(line) then
	    if linesRead=0 then
		if verbose then
		    puts(1,"This .INI file is blank. Please reload previous file.\n")
		--end if
		--end if
		end if
	    end if
	    exit
	end if
	linesRead+=1
	line=strip(line,'\r')
	if length(line)=1 then
	    line=gets(fn)
	    if atom(line) then
		exit
	    end if
	end if
	-- NEW! IE1.4a Put lineIsSection flag to use. It now says that the line
	-- is a section.
	lineIsSection=0
	if commentAtEnd(line) then
	    if line[1]='[' or find(']',line) then
		if find(']',line) then
		    lineIsSection=1
		end if
	    end if
	end if
	if line[1]!='[' and line[length(line)-1]=']' and lineIsSection = 0 then
	    line = '['&line
	    if verbose then
		puts(1,"A section name with no open '[' character was found.\n"&
		       "It has been added automatically.\n")
	    end if
	end if
	if line[1]='[' then
	if line[length(line)-1]!=']' and lineIsSection = 0 then
	    line=line[1..length(line)-1]
	    line &= "]\n"
	    if verbose then
		puts(1,"A section name with no closing ']' character was found.\n"&
		       "It has been added automatically")
	    end if
	 end if
	 end if
	 if line[length(line)-1]=']' or
	    equal(line[length(line)-1..length(line)],"]\n") then
	     numberOfSections+=1
		sections &= {line[1..length(line)-1]}
		sectText &= {""}
		while 1 do
		    fpos=where(fn)
		    line=gets(fn)
		    if atom(line) or length(line)=0 then
			exit
		    end if
		    if line[1]='\n' then
			fpos=where(fn)
			line=gets(fn)
			if atom(line) then
			    if seek(fn,fpos) then
			    end if
			    exit
			elsif isVar(line)=0 then
			    if line[1]='[' or line[length(line)-1]=']' then
			    if seek(fn,fpos) then
			    end if
			    exit
			end if
			end if
		    end if
		    if atom(line) then
			exit
		    end if
		    if isVar(line)=0 then
		    if line[1]='[' or line[length(line)-1] = ']' then
			-- In cases in which one section comes immediately after
			-- the current one
			if seek(fn,fpos) then
			end if
			exit
		    end if
		    end if
		    slice=1
		    newLine=""
		    if length(line)=1 then
			if line[1]=10 or line[1]=13 then
			    exit
			end if
		    else
			if line[1]='[' and line[length(line)-1]=']' then
			    sections &= {line[1..length(line)-1]}
			    sectText &= {""}
			    numberOfSections += 1
			    line=""
			end if
		    end if
		    -- To make section text compatible with MLEs, make LF a
		    -- CRLF.
		    for z = 1 to length(line) do
			slice=z
			if line[z]='\n' then
			    if z<length(line) then
				if line[z+1]!='\r' then
				    newLine &= '\r'
				    slice += 1
				end if
			    else
				newLine &= '\r'
				slice += 1
			    end if
			end if
			newLine &= line[z]
		    end for
		    sectText[numberOfSections] &= newLine
		end while
	    end if
	    --end if
	--end if
    end while
    close(fn)
    return {sections,sectText}
end function
global function ParseCRLF(sequence longStr) -- Seperates CRLF seperated strings into
				     -- sequence of words.
    sequence new,buffr
    new={}
    buffr=""
    for z = 1 to length(longStr) do
	if longStr[z]='\r' then -- Reached end of line
	    new &= {buffr} -- Flush buffer into sequence of words
	    buffr = ""
	elsif longStr[z]='\n' then -- The other end of line character.
	    -- Ignore
	else -- Some other character
	    buffr &= longStr[z] -- Add to buffer
	end if
    end for
    return new
end function
global function FindVar(sequence sect,sequence vname)
    integer indx
    indx = find2(vname,sect)
    if indx > 0 then
	return sect[indx][find('=',sect[indx])+1..length(sect[indx])]
    else
	return ""
    end if
end function

