without warning -- Suppress warning messages

-- EuSetup
-- A simple setup tool using Euphoria
-- Version 1.1 - Uses DOS.E instead of DOS 6 commands
-- Version 1.2 - After hours of toil(1 at least), I did it! I added support for
--               an INI file!
-- Version 1.3 - Support for compressed and bundled files
include file.e -- dir(), allow_break(), check_break()
include image.e -- display/save_text_image()
include graphics.e -- text/bk_color()
include ini.e -- INI file reading
include dos.e -- DOS 6 functions
include get.e
include bundle.e
include wildcard.e
sequence title,tree,files,scrn,vc,list,data,oldpos,cmd,temp,sectText,tre,fl,
	 compressed,bundled,scr2,pos2,bundleFile,trouble
object sections,dr -- -1 is a possible result of readINIFile
integer fn,r,notfound,fils,errcode,key,noask,numOfFiles,justCopy,cantcreate,
	TitleColor,MessageColor,BarColor,tmp2,tmp3,ec2,tlog,ok,bundlerr
bundlerr=0
bundleFile="bundle.dat"
constant NOTHING = 0, -- Bit fields indicating file status
	 HUFFED  = 1,
	 BUNDLED = 2
tree={}
files={}
bundled={}
trouble={}
compressed={}
function vl(sequence st)
    sequence nm
    nm=value(st)
    return nm[2]
end function
procedure abortErr(sequence err,object data,integer code)
    printf(1,err,data)
    if code>0 then abort(code) end if
end procedure
noask = 0 -- "Don't confirm directory delete" flag. Default = Yes
justCopy=0 -- "Just copy and don't bother deleting the original" flag ...
numOfFiles=1  -- ...Default = No
notfound=0 -- "I didn't find it" flag.
fils=1
r=4
cantcreate=0
ok=1
procedure doQuitStuff()
    display_text_image({1,1},scrn)
    position(oldpos[1],oldpos[2])
    closeBundles()
    puts(tlog,"\n---\nEOF\n---\n\n")
    close(tlog)
end procedure
procedure cls2() -- Clear area below title.
    for z=4 to vc[VC_LINES] do
	position(z,1)
	puts(1,repeat(' ',vc[VC_COLUMNS]))
    end for
end procedure
procedure bar(integer r,integer c,integer len,integer full) -- Draw bar
    sequence oldp
    oldp=get_position()
    position(r,c)
    puts(1,repeat(176,len))
    position(r,c)
    puts(1,repeat(219,full))
    position(oldp[1],oldp[2])
end procedure
function ucase(object st) -- Convert to uppercase. Atoms are treated as length-1
    if atom(st) then      -- sequences.
	if st>='a' and st<='z' then
	    st -= ' '
	end if
	return st
    end if
    for z = 1 to length(st) do
	if st[z]>='a' and st[z]<='z' then
	    st[z] -= ' '
	end if
    end for
    return st
end function
function foundit(sequence list,object data) -- Search extensively.
    for z = 1 to length(list) do
	for y = 1 to length(list[z]) do
	    if equal(data,list[z][y]) then
		return 1
	    end if
	end for
    end for
    return 0
end function
function ucaseall(sequence seq)
    for z = 1 to length(seq) do
	seq[z]=ucase(seq[z])
    end for
    return seq
end function
cmd=command_line()
if find("/Y",ucaseall(cmd)) then
    noask = 1
end if
if find("/C",ucaseall(cmd)) then
    justCopy=1
end if
wrap(0)
vc=video_config()
sections=readINIFile("setup.ini")
if atom(sections) then
    abortErr("Couldn't open setup.ini!\n",{},1)
end if
sectText=sections[2]
sections=sections[1]
if length(sectText)<2 then
    abortErr("Must have at least one directory to send files to!\n",{},2)
end if
for z = 1 to length(sectText) do
    sectText[z]=parse_delim(sectText[z][1..length(sectText[z])-2],'\r')
end for
if length(sectText[1])<2 then
    abortErr("Not enough data in [EuSetup] section\n",{},0)
end if
title=assignIConst(sectText[1][1])
temp=parse_delim(assignIConst(sectText[1][2]),',')
if length(temp)<3 then
    abortErr("Colors data too short!",{},3)
end if
TitleColor=vl(temp[1])
MessageColor=vl(temp[2])
BarColor=vl(temp[3])
if length(sectText[1])=3 then
    bundleFile=assignIConst(sectText[1][3])
end if
for z = 2 to length(sectText) do
    tree &= {assignIConst(sectText[z][1])}
    files &= {{}}
    for x = 2 to length(sectText[z]) do
	temp = assignIConst(sectText[z][x])
	if length(temp)>3 then
	if temp[length(temp)-1]=',' then
	    -- This file must be compressed, bundled, or both
	    tmp2=temp[length(temp)]-'0'
	    temp=temp[1..length(temp)-2]
	    if and_bits(tmp2,HUFFED)=HUFFED then -- Huffman was used
		compressed &= {temp}
	    end if
	    if and_bits(tmp2,BUNDLED)=BUNDLED then -- This file was bundled
		bundled &= {temp}
	    end if
	end if
	end if
	files[z-1] &= {temp}
    end for
end for
if length(compressed) then
    dr=dir("dehuff.exe")
    if atom(dr) then
	puts(1,"Error!\n")
	puts(1,"There are 1 or more files that require the decompressor dehuff.exe, which I\n")
	puts(1,"couldn't find. Please contact me at Prog_Matt@Yahoo.com.")
	abort(1)
    end if
end if
if length(bundled) then
    errcode=openBundle(bundleFile) -- open bundleFile for dynamic read
    if errcode = -1 then
	puts(1,"The file '"&bundleFile&"' couldn't be found, and I need this file\n")
	puts(1,"Try looking for it. If you can't find it, contact your vendor.\n")
    end if
end if
scrn=save_text_image({1,1},{vc[VC_LINES],vc[VC_COLUMNS]}) -- Save our screen,
oldpos=get_position()
text_color(TitleColor) bk_color(BLUE) -- Set the colors to title color on blue
clear_screen() -- And clear the screen
title &= " - EuSetup (c) Matt Arriola 1999"
puts(1,"\n  "&title&"\n "&repeat(196,vc[VC_COLUMNS]-3)) -- Display the title
list=dir(current_dir()) -- Get a file listing
text_color(MessageColor) -- Set the message area text color
position(4,3)
allow_break(0)
puts(1,"Checking for files...\n") -- Display message
for z = 1 to length(files) do -- Figure the number of files specified
    for y = 1 to length(files[z]) do
	numOfFiles += 1
    end for
end for
tlog=open("trouble.txt","a")
temp=date()
temp=sprintf("EuSetup error log, %d:%02d %02d/%02d/%04d",{temp[4],temp[5],temp[2],
	 temp[3],temp[1]+1900})
puts(tlog,temp)
puts(tlog,'\n'&repeat(196,length(temp)+1)&'\n')
puts(tlog,"\nFile checkup:\n")
puts(tlog,"\n")
ok=1
for z = 1 to length(files) do -- Scan the list and make sure each file exists
    for y = 1 to length(files[z]) do
	position(4,22)
	puts(1,repeat(' ',58))
	position(4,22)
	puts(1,files[z][y])
	if find(upper(files[z][y]),upper(bundled)) then
	    puts(1,"(Bundled)")
	end if
	if foundit(list,ucase(files[z][y]))=0 and not find(upper(files[z][y]),upper(bundled)) then
	    position(r,3)
	    puts(1,"File not found: "&files[z][y])
	    puts(tlog,"File not found: "&files[z][y]&'\n')
	    ok=0
	    r += 1
	    notfound=1
	end if
	text_color(BarColor)
	bar(24,5,70,floor(z*(70/fils)))
	text_color(MessageColor)
	fils += 1
    end for
end for
if ok = 1 then
    puts(tlog,"OK!\n\n")
end if
cls2()
if notfound then
    position(r,3)
    puts(1,"Some files were not found. Hit any key to exit.\n")
    while get_key()=-1 do
    end while
    doQuitStuff()
    abort(1)
end if
bar(24,5,70,70)
position(4,3)
puts(1,"All files found!     ")
position(5,3)
puts(1,"Hit any key to install...")
while get_key()=-1 do
end while
-- Because I got DOS.E, the echof.bat temporary file is no longer needed
cls2() -- Clear message area
r=4
puts(tlog,"Directory structure test/create\n")
puts(tlog,"\n")
ok=0
for z = 1 to length(tree) do -- Scan directory list
    -- Does the directory already exist?
    if foundit(list,ucase(tree[z][1..length(tree[z])-1]))=1 then
	-- Tell user.
	position(r,3)
	puts(1,"The directory "&tree[z]&" already exists. Overwrite(Y/N)? ")
	r += 1
	-- Ask if they want to recreate it
	if noask = 0 then key=upper(wait_key()) else key = 'Y' end if
	if key='Y' then
	    -- Do a deltree on it
	    errcode=deltree(tree[z][1..length(tree[z])-1])
	    if errcode=0 then
		position(r,3)
		puts(1,"Unable to delete: '"&tree[z]&'\'')
		puts(tlog,"Test: Can't delete: "&tree[z]&'\n')
		if ok = 1 then
		    ok=3
		else
		    ok=2
		end if
		r += 1
		cantcreate=1
	    end if
	end if
    end if
	errcode=mkdir(tree[z][1..length(tree[z])-1])
	if not errcode then
	    position(r,3)
	    puts(1,"Unable to create: '"&tree[z]&'\'')
	    puts(tlog,"Create: Can't create: "&tree[z]&'\n')
	    if ok = 2 then
		ok = 3
	    else
		ok = 1
	    end if
	    r += 1
	    cantcreate=1
	end if
    --end if
end for
if and_bits(ok,2) != 2 then
    puts(tlog,"Structure test: OK!\n")
end if
if and_bits(ok,1) != 1 then
    puts(tlog,"Structure create: OK!\n")
end if
ok=1
cls2() -- Clear the message area
position(4,3)
puts(1,"Installing files...")
r=4
fils=0
notfound = 0
puts(tlog,"\nFile installation\n")
puts(tlog,"\n")
for z = 1 to length(files) do -- Scan the list of files
    for y = 1 to length(files[z]) do
	-- And install each one to the right directory
	temp=files[z][y]
	if find(temp,bundled) then
	    errcode=unBundle(bundleFile,temp)
	    if errcode=BUNDLE_NOT_FOUND2 and not bundlerr then
		position(r,3)
		puts(1,"The file '"&bundleFile&"' wasn't found. Because of this, '"&temp&'\'')
		position(r+1,3)
		puts(1,"can't be created.")
		puts(tlog,"Bundle file not found: "&bundleFile&'\n')
		ok=0
		r += 2
		cantcreate = 1
		bundlerr=1
	    elsif errcode=BUNDLE_NOT_FOUND then
		position(r,3)
		puts(1,"The file '"&temp&"' couldn't be created")
		puts(tlog,"Can't unbundle file: "&temp&'\n')
		ok=0
		r += 1
		cantcreate = 1
	    end if
	end if
	if justCopy=0 then -- If the copy flag is 0
	    --  the file
	    errcode=move(temp,tree[z]&temp)
	else
	    -- Otherwise, just copy
	    if not find(upper(temp),upper(bundled)) then
		fn=open(tree[z]&temp,"wb")
		close(fn)
		errcode=copy(temp,tree[z]&temp) -- Bundled files don't count
	    else
		errcode=move(temp,tree[z]&temp) -- Bundled files don't count
	    end if
	end if
	if not errcode then -- Couldn't copy a file!
	    -- Tell user
	    position(r,3)
	    puts(1,"Unable to copy to destination: "&temp)
	    puts(tlog,"Couldn't copy '"&temp&"' to '"&tree[z]&temp&"'\n")
	    ok=0
	    cantcreate = 1
	    r += 1
	end if
	if find(upper(temp),upper(compressed)) then
	    scr2=save_text_image({1,1},vc[3..4])
	    pos2=get_position()
	    ec2=system_exec("dehuff "&tree[z]&temp,2)
	    display_text_image({1,1},scr2)
	    position(pos2[1],pos2[2])
	    if ec2 > 0 then
		position(r,3)
		puts(1,"An error occurred while decompressing: "&temp)
		puts(tlog,"Unable to decompress '"&temp&"'\n")
		ok=0
		cantcreate = 1
		r += 1
	    end if
	    errcode=delete(tree[z]&temp)
	    if errcode = 0 then
		position(r,3)
		puts(1,"Step two of decompression(deleting original file) failed\n")
		puts(tlog,"Couldn't delete original uncompressed '"&temp&"'\n")
		ok=0
		cantcreate = 1
		r += 1
	    end if
	    errcode=move("dehuff.out",tree[z]&temp)
	    if errcode = 0 then
		position(r,3)
		puts(1,"Step three of decompression(moving dehuff.out to original file) failed\n")
		puts(tlog,"Couldn't copy decompressed output file to '"&tree[z]&temp&"'\n")
		ok=0
		cantcreate = 1
		r += 1
	    end if
	end if
	text_color(BarColor)
	bar(24,5,70,floor(z*(70/numOfFiles)))
	text_color(MessageColor)
	fils += 1
    end for
end for
if cantcreate then
    while get_key()=-1 do
    end while
end if
cls2() -- Clear the message area
if not notfound then -- If all files were installed right
    -- And tell them:
    position(4,3)
    puts(1,"All files were installed successfully. Hit any key to exit.\n")
    puts(tlog,"OK!\n")
    for z = 1 to length(compressed) do
	if find(compressed[z],bundled) then
	    position(5,3)
	    puts(1,"1 or more files are compressed and bundled. There's a bug in my bundle code\n")
	    puts(1,"makes compressed and bundled code unreadable in some parts\n")
	    puts(tlog,"\nNote: 1 or more file are compressed AND bundled. Due to the bundling code,\n")
	    puts(tlog,"several parts of your decompressed and bundled files may be garbage\n")
	    exit
	end if
    end for
    bar(24,5,70,70)
    while get_key()=-1 do -- Wait for a key
    end while
end if
if cantcreate then
    -- It didn't work, so tell the user.
    position(4,3)
    puts(1,"Some files were either unable to be copied, or directories unable")
    position(5,3)
    puts(1,"to be created/destroyed. Please make sure files files/dirs aren't")
    position(6,3)
    puts(1,"read-only. Hit any key to exit.\n")
    while get_key()=-1 do
    end while
end if
doQuitStuff()

